(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 7.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[     12527,        381]
NotebookOptionsPosition[     11819,        357]
NotebookOutlinePosition[     12157,        372]
CellTagsIndexPosition[     12114,        369]
WindowFrame->Generic*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell[BoxData[
 StyleBox[
  RowBox[{"(*", " ", 
   RowBox[{
   "Eigenvalues", " ", "of", " ", "a", " ", "triangular", " ", "symmetric", 
    " ", "matrix", " ", "by", " ", "repeated", " ", "use", " ", "of", " ", 
    "the", " ", "symmetric", " ", "QR", " ", "reduction", " ", "using", " ", 
    "the", " ", "Wilkinson", " ", "implicit", " ", "shift"}], " ", "*)"}],
  FontSize->16]], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellChangeTimes->{{3.473736525904811*^9, 3.473736609734975*^9}, 
   3.473736704209207*^9}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"(*", " ", 
    RowBox[{
     RowBox[{"Jacobi", "-", 
      RowBox[{"Givens", " ", 
       RowBox[{"rotation", ":", "\[IndentingNewLine]", 
        RowBox[{"returns", " ", "the", " ", "ordered", " ", 
         RowBox[{"pair", ":", " ", "cos"}]}]}]}]}], ",", " ", "sin"}], " ", 
    "*)"}],
   FontSize->16], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"givens", "[", 
    RowBox[{"a_", ",", "b_"}], "]"}], " ", ":=", " ", 
   RowBox[{"If", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Abs", "[", "b", "]"}], ">", 
      RowBox[{"Abs", "[", "a", "]"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", "tau", "}"}], ",", " ", 
       RowBox[{
        RowBox[{"tau", "=", 
         RowBox[{
          RowBox[{"-", "a"}], "/", "b"}]}], ";", " ", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"tau", ",", "1"}], "}"}], "/", 
         RowBox[{"Sqrt", "[", 
          RowBox[{"1", "+", 
           RowBox[{"tau", "^", "2"}]}], "]"}]}]}]}], "]"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", "tau", "}"}], ",", " ", 
       RowBox[{
        RowBox[{"tau", "=", 
         RowBox[{
          RowBox[{"-", "b"}], "/", "a"}]}], ";", " ", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "tau"}], "}"}], "/", 
         RowBox[{"Sqrt", "[", 
          RowBox[{"1", "+", 
           RowBox[{"tau", "^", "2"}]}], "]"}]}]}]}], "]"}]}], 
    "]"}]}]}]], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellChangeTimes->{{3.473736485501217*^9, 3.473736491816851*^9}, 
   3.473736704209251*^9}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"(*", " ", 
    RowBox[{"Show", " ", "Gershgorin", " ", "disks"}], " ", "*)"}],
   FontSize->16], 
  RowBox[{
   RowBox[{"gdisk", "[", "m_", "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"x", ",", "y"}], "}"}], ",", 
     RowBox[{"ContourPlot", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{"x", "-", 
              RowBox[{"m", "[", 
               RowBox[{"[", 
                RowBox[{"1", ",", "1"}], "]"}], "]"}]}], ")"}], "^", "2"}], 
           "+", 
           RowBox[{"y", "^", "2"}]}], "\[Equal]", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"Abs", "[", 
              RowBox[{"m", "[", 
               RowBox[{"[", 
                RowBox[{"1", ",", "2"}], "]"}], "]"}], "]"}], "+", 
             RowBox[{"Abs", "[", 
              RowBox[{"m", "[", 
               RowBox[{"[", 
                RowBox[{"1", ",", "3"}], "]"}], "]"}], "]"}]}], ")"}], "^", 
           "2"}]}], ",", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{"x", "-", 
              RowBox[{"m", "[", 
               RowBox[{"[", 
                RowBox[{"2", ",", "2"}], "]"}], "]"}]}], ")"}], "^", "2"}], 
           "+", 
           RowBox[{"y", "^", "2"}]}], "\[Equal]", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"Abs", "[", 
              RowBox[{"m", "[", 
               RowBox[{"[", 
                RowBox[{"2", ",", "1"}], "]"}], "]"}], "]"}], "+", 
             RowBox[{"Abs", "[", 
              RowBox[{"m", "[", 
               RowBox[{"[", 
                RowBox[{"2", ",", "3"}], "]"}], "]"}], "]"}]}], ")"}], "^", 
           "2"}]}], ",", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{"x", "-", 
              RowBox[{"m", "[", 
               RowBox[{"[", 
                RowBox[{"3", ",", "3"}], "]"}], "]"}]}], ")"}], "^", "2"}], 
           "+", 
           RowBox[{"y", "^", "2"}]}], "\[Equal]", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"Abs", "[", 
              RowBox[{"m", "[", 
               RowBox[{"[", 
                RowBox[{"3", ",", "1"}], "]"}], "]"}], "]"}], "+", 
             RowBox[{"Abs", "[", 
              RowBox[{"m", "[", 
               RowBox[{"[", 
                RowBox[{"3", ",", "2"}], "]"}], "]"}], "]"}]}], ")"}], "^", 
           "2"}]}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"x", ",", 
         RowBox[{"-", "5"}], ",", "15"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"y", ",", 
         RowBox[{"-", "10"}], ",", "10"}], "}"}], ",", 
       RowBox[{"ContourStyle", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"Red", ",", "Blue", ",", "Black"}], "}"}]}]}], "]"}]}], 
    "]"}]}]}]], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellChangeTimes->{{3.473735558321961*^9, 3.473735559422346*^9}, {
   3.47373626496148*^9, 3.47373627272978*^9}, {3.47373641445347*^9, 
   3.473736428979384*^9}, 3.473736704209284*^9}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"(*", " ", 
    RowBox[{
     RowBox[{"Give", " ", "an", " ", "input", " ", "tri"}], "-", 
     RowBox[{"diagonal", " ", "matrix"}]}], " ", "*)"}],
   FontSize->16], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"t", "=", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1.", ",", 
         RowBox[{"Sqrt", "[", "13.", "]"}], ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Sqrt", "[", "13.", "]"}], ",", "10.", ",", "1."}], "}"}], 
       ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "1.", ",", "0."}], "}"}]}], "}"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"MatrixForm", "[", "t", "]"}], "\[IndentingNewLine]", 
   RowBox[{"pl1", "=", 
    RowBox[{"gdisk", "[", "t", "]"}]}]}]}]], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellChangeTimes->{{3.473735331134318*^9, 3.473735362850776*^9}, {
   3.473735570926861*^9, 3.473735574663619*^9}, {3.473736328864314*^9, 
   3.47373633001772*^9}, 3.473736704209316*^9}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"(*", " ", 
    RowBox[{
    "Implicit", " ", "symmetric", " ", "QR", " ", "step", " ", "with", " ", 
     "Wilkinson", " ", "shift"}], " ", "*)"}],
   FontSize->16], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"d", "=", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"t", "[", 
        RowBox[{"[", 
         RowBox[{"2", ",", "2"}], "]"}], "]"}], "-", 
       RowBox[{"t", "[", 
        RowBox[{"[", 
         RowBox[{"3", ",", "3"}], "]"}], "]"}]}], ")"}], "/", "2"}]}], 
   "\[IndentingNewLine]", 
   RowBox[{"mu", "=", 
    RowBox[{
     RowBox[{"t", "[", 
      RowBox[{"[", 
       RowBox[{"3", ",", "3"}], "]"}], "]"}], " ", "-", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"t", "[", 
        RowBox[{"[", 
         RowBox[{"3", ",", "2"}], "]"}], "]"}], "^", "2"}], "/", 
      RowBox[{"(", 
       RowBox[{"d", "+", 
        RowBox[{
         RowBox[{"Sign", "[", "d", "]"}], " ", 
         RowBox[{"Sqrt", "[", 
          RowBox[{
           RowBox[{"d", "^", "2"}], "+", 
           RowBox[{
            RowBox[{"t", "[", 
             RowBox[{"[", 
              RowBox[{"3", ",", "2"}], "]"}], "]"}], "^", "2"}]}], "]"}]}]}], 
       ")"}]}]}]}], "\[IndentingNewLine]", 
   RowBox[{"x", "=", 
    RowBox[{
     RowBox[{"t", "[", 
      RowBox[{"[", 
       RowBox[{"1", ",", "1"}], "]"}], "]"}], "-", "mu"}]}], 
   "\[IndentingNewLine]", 
   RowBox[{"z", "=", 
    RowBox[{"t", "[", 
     RowBox[{"[", 
      RowBox[{"2", ",", "1"}], "]"}], "]"}]}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{"First", " ", "pass", " ", "through", " ", "the", " ", "loop"}], 
     " ", "*)"}],
    FontSize->14], "\[IndentingNewLine]", 
   RowBox[{"k", "=", "1"}], "\[IndentingNewLine]", 
   RowBox[{"cs", "=", 
    RowBox[{"givens", "[", 
     RowBox[{"x", ",", "z"}], "]"}]}], "\[IndentingNewLine]", 
   RowBox[{"giv", "=", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"cs", "[", 
         RowBox[{"[", "1", "]"}], "]"}], ",", 
        RowBox[{"cs", "[", 
         RowBox[{"[", "2", "]"}], "]"}], ",", "0"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", 
         RowBox[{"cs", "[", 
          RowBox[{"[", "2", "]"}], "]"}]}], ",", 
        RowBox[{"cs", "[", 
         RowBox[{"[", "1", "]"}], "]"}], ",", "0"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"0", ",", "0", ",", "1"}], "}"}]}], "}"}]}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"t", "=", 
     RowBox[{
      RowBox[{"Transpose", "[", "giv", "]"}], ".", "t", ".", "giv"}]}], ";"}],
    "\[IndentingNewLine]", 
   RowBox[{"MatrixForm", "[", "t", "]"}], "\[IndentingNewLine]", 
   RowBox[{"x", "=", 
    RowBox[{"t", "[", 
     RowBox[{"[", 
      RowBox[{
       RowBox[{"k", "+", "1"}], ",", "k"}], "]"}], "]"}]}], 
   "\[IndentingNewLine]", 
   RowBox[{"z", "=", 
    RowBox[{"t", "[", 
     RowBox[{"[", 
      RowBox[{
       RowBox[{"k", "+", "2"}], ",", "k"}], "]"}], "]"}]}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{"Second", " ", "pass", " ", "through", " ", "the", " ", "loop"}],
      " ", "*)"}],
    FontSize->14], "\[IndentingNewLine]", 
   RowBox[{"k", "=", "2"}], "\[IndentingNewLine]", 
   RowBox[{"cs", "=", 
    RowBox[{"givens", "[", 
     RowBox[{"x", ",", "z"}], "]"}]}], "\[IndentingNewLine]", 
   RowBox[{"giv", "=", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "0", ",", "0"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"0", ",", 
        RowBox[{"cs", "[", 
         RowBox[{"[", "1", "]"}], "]"}], ",", 
        RowBox[{"cs", "[", 
         RowBox[{"[", "2", "]"}], "]"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"0", ",", 
        RowBox[{"-", 
         RowBox[{"cs", "[", 
          RowBox[{"[", "2", "]"}], "]"}]}], ",", 
        RowBox[{"cs", "[", 
         RowBox[{"[", "1", "]"}], "]"}]}], "}"}]}], "}"}]}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"t", "=", 
     RowBox[{
      RowBox[{"Transpose", "[", "giv", "]"}], ".", "t", ".", "giv"}]}], ";"}],
    "\[IndentingNewLine]", 
   RowBox[{"MatrixForm", "[", "t", "]"}], "\[IndentingNewLine]", 
   RowBox[{"pl2", "=", 
    RowBox[{"gdisk", "[", "t", "]"}]}]}]}]], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellChangeTimes->{{3.473733360263757*^9, 3.473733367418367*^9}, {
   3.473733449942077*^9, 3.473733469587961*^9}, {3.473733508677622*^9, 
   3.473733551274113*^9}, {3.473735353260154*^9, 3.47373535662459*^9}, {
   3.473736317303361*^9, 3.473736336317802*^9}, 3.473736704209348*^9}]
}, Closed]]
},
WindowSize->{640, 750},
WindowMargins->{{373, Automatic}, {Automatic, 64}},
FrontEndVersion->"7.0 for Linux x86 (32-bit) (February 25, 2009)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[568, 22, 536, 11, 118, "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.}],
Cell[1107, 35, 1676, 50, 121, "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.}],
Cell[2786, 87, 3259, 95, 187, "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.}],
Cell[6048, 184, 1065, 29, 99, "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.}],
Cell[7116, 215, 4687, 139, 517, "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.}]
}, Closed]]
}
]
*)

(* End of internal cache information *)

