(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 7.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[     11626,        332]
NotebookOptionsPosition[     10995,        309]
NotebookOutlinePosition[     11354,        325]
CellTagsIndexPosition[     11311,        322]
WindowFrame->Generic*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell[BoxData[
 StyleBox[
  RowBox[{"(*", " ", 
   RowBox[{
   "Plot", " ", "Gershgorin", " ", "disks", " ", "for", " ", "3", " ", "by", 
    " ", "3", " ", "matrices"}], " ", "*)"}],
  FontSize->16]], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellChangeTimes->{3.473560127419969*^9}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"(*", " ", 
    RowBox[{"Show", " ", "Gershgorin", " ", "disks"}], " ", "*)"}],
   FontSize->16], "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"gdisk", "[", "m_", "]"}], " ", ":=", " ", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"x", ",", "y"}], "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{"ContourPlot", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{"(", 
              RowBox[{"x", "-", 
               RowBox[{"m", "[", 
                RowBox[{"[", 
                 RowBox[{"1", ",", "1"}], "]"}], "]"}]}], ")"}], "^", "2"}], 
            "+", 
            RowBox[{"y", "^", "2"}]}], "\[Equal]", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"Abs", "[", 
               RowBox[{"m", "[", 
                RowBox[{"[", 
                 RowBox[{"1", ",", "2"}], "]"}], "]"}], "]"}], "+", 
              RowBox[{"Abs", "[", 
               RowBox[{"m", "[", 
                RowBox[{"[", 
                 RowBox[{"1", ",", "3"}], "]"}], "]"}], "]"}]}], ")"}], "^", 
            "2"}]}], " ", ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{"(", 
              RowBox[{"x", "-", 
               RowBox[{"m", "[", 
                RowBox[{"[", 
                 RowBox[{"2", ",", "2"}], "]"}], "]"}]}], ")"}], "^", "2"}], 
            "+", 
            RowBox[{"y", "^", "2"}]}], "\[Equal]", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"Abs", "[", 
               RowBox[{"m", "[", 
                RowBox[{"[", 
                 RowBox[{"2", ",", "1"}], "]"}], "]"}], "]"}], "+", 
              RowBox[{"Abs", "[", 
               RowBox[{"m", "[", 
                RowBox[{"[", 
                 RowBox[{"2", ",", "3"}], "]"}], "]"}], "]"}]}], ")"}], "^", 
            "2"}]}], ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{"(", 
              RowBox[{"x", "-", 
               RowBox[{"m", "[", 
                RowBox[{"[", 
                 RowBox[{"3", ",", "3"}], "]"}], "]"}]}], ")"}], "^", "2"}], 
            "+", 
            RowBox[{"y", "^", "2"}]}], "\[Equal]", " ", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"Abs", "[", 
               RowBox[{"m", "[", 
                RowBox[{"[", 
                 RowBox[{"3", ",", "1"}], "]"}], "]"}], "]"}], "+", 
              RowBox[{"Abs", "[", 
               RowBox[{"m", "[", 
                RowBox[{"[", 
                 RowBox[{"3", ",", "2"}], "]"}], "]"}], "]"}]}], ")"}], "^", 
            "2"}]}], " ", ",", "\[IndentingNewLine]", " ", 
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{"(", 
              RowBox[{"x", "-", 
               RowBox[{"m", "[", 
                RowBox[{"[", 
                 RowBox[{"1", ",", "1"}], "]"}], "]"}]}], ")"}], "^", "2"}], 
            "+", 
            RowBox[{"y", "^", "2"}]}], "\[Equal]", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"Abs", "[", 
               RowBox[{"m", "[", 
                RowBox[{"[", 
                 RowBox[{"2", ",", "1"}], "]"}], "]"}], "]"}], "+", 
              RowBox[{"Abs", "[", 
               RowBox[{"m", "[", 
                RowBox[{"[", 
                 RowBox[{"3", ",", "1"}], "]"}], "]"}], "]"}]}], ")"}], "^", 
            "2"}]}], ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{"(", 
              RowBox[{"x", "-", 
               RowBox[{"m", "[", 
                RowBox[{"[", 
                 RowBox[{"2", ",", "2"}], "]"}], "]"}]}], ")"}], "^", "2"}], 
            "+", 
            RowBox[{"y", "^", "2"}]}], "\[Equal]", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"Abs", "[", 
               RowBox[{"m", "[", 
                RowBox[{"[", 
                 RowBox[{"1", ",", "2"}], "]"}], "]"}], "]"}], "+", 
              RowBox[{"Abs", "[", 
               RowBox[{"m", "[", 
                RowBox[{"[", 
                 RowBox[{"3", ",", "2"}], "]"}], "]"}], "]"}]}], ")"}], "^", 
            "2"}]}], ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{"(", 
              RowBox[{"x", "-", 
               RowBox[{"m", "[", 
                RowBox[{"[", 
                 RowBox[{"3", ",", "3"}], "]"}], "]"}]}], ")"}], "^", "2"}], 
            "+", 
            RowBox[{"y", "^", "2"}]}], "\[Equal]", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"Abs", "[", 
               RowBox[{"m", "[", 
                RowBox[{"[", 
                 RowBox[{"1", ",", "3"}], "]"}], "]"}], "]"}], "+", 
              RowBox[{"Abs", "[", 
               RowBox[{"m", "[", 
                RowBox[{"[", 
                 RowBox[{"2", ",", "3"}], "]"}], "]"}], "]"}]}], ")"}], "^", 
            "2"}]}]}], " ", "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"x", ",", 
          RowBox[{"-", "20"}], ",", "20"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"y", ",", 
          RowBox[{"-", "20"}], ",", "20"}], "}"}], ",", 
        RowBox[{"ContourStyle", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"Red", ",", "Blue", ",", "Black", ",", " ", 
           RowBox[{"Directive", "[", 
            RowBox[{"Red", ",", "Dashed"}], "]"}], ",", " ", 
           RowBox[{"Directive", "[", 
            RowBox[{"Blue", ",", "Dashed"}], "]"}], ",", 
           RowBox[{"Directive", "[", 
            RowBox[{"Black", ",", "Dashed"}], "]"}]}], "}"}]}]}], "]"}]}], 
     "]"}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"anim", "[", "m_", "]"}], " ", ":=", " ", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"a", ",", "b", ",", "i", ",", "j", ",", "p", ",", "phi"}], 
       "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"a", "=", 
        RowBox[{"Table", "[", 
         RowBox[{"0", ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", "3"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"j", ",", "3"}], "}"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"a", "[", 
         RowBox[{"[", 
          RowBox[{"1", ",", "1"}], "]"}], "]"}], "=", "1"}], ";", " ", 
       RowBox[{
        RowBox[{"a", "[", 
         RowBox[{"[", 
          RowBox[{"2", ",", "2"}], "]"}], "]"}], "=", 
        RowBox[{"Cos", "[", "phi", "]"}]}], ";", " ", 
       RowBox[{
        RowBox[{"a", "[", 
         RowBox[{"[", 
          RowBox[{"3", ",", "3"}], "]"}], "]"}], "=", 
        RowBox[{"a", "[", 
         RowBox[{"[", 
          RowBox[{"2", ",", "2"}], "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"a", "[", 
         RowBox[{"[", 
          RowBox[{"2", ",", "3"}], "]"}], "]"}], "=", 
        RowBox[{"Sin", "[", "phi", "]"}]}], ";", " ", 
       RowBox[{
        RowBox[{"a", "[", 
         RowBox[{"[", 
          RowBox[{"3", ",", "2"}], "]"}], "]"}], "=", 
        RowBox[{"-", 
         RowBox[{"a", "[", 
          RowBox[{"[", 
           RowBox[{"2", ",", "3"}], "]"}], "]"}]}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"b", "=", 
        RowBox[{"Transpose", "[", "a", "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"p", "=", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"gdisk", "[", 
           RowBox[{
            RowBox[{"b", ".", "m", ".", "a"}], "  ", "/.", " ", 
            RowBox[{"phi", " ", "\[Rule]", " ", 
             RowBox[{"i", " ", 
              RowBox[{"Pi", "/", "40"}]}]}]}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", "80"}], "}"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"ListAnimate", "[", "p", "]"}]}]}], "]"}]}]}]}]], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellChangeTimes->{{3.473560033825888*^9, 3.473560127420011*^9}, {
  3.473582177841351*^9, 3.473582190842106*^9}, {3.473582228338829*^9, 
  3.473582233175892*^9}, {3.473582362275632*^9, 3.473582389682045*^9}, {
  3.473582474766357*^9, 3.473582476446745*^9}, {3.473582844110029*^9, 
  3.473582848740392*^9}, {3.473583004809584*^9, 3.473583053231105*^9}, {
  3.473583085232244*^9, 3.473583113175882*^9}, {3.473583148586015*^9, 
  3.473583173450975*^9}, {3.473583286268234*^9, 3.473583306836333*^9}, {
  3.473583474129201*^9, 3.473583489108056*^9}, {3.473583850223616*^9, 
  3.473583906700705*^9}, {3.473584070577962*^9, 3.473584073456804*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"m", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"15", ",", 
       RowBox[{"-", "3"}], ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", 
       RowBox[{"-", "2"}], ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "6", ",", "1"}], "}"}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"N", "[", 
  RowBox[{"Eigenvalues", "[", "m", "]"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"anim", "[", "m", "]"}]}], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellChangeTimes->{{3.473560114238935*^9, 3.473560127420051*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"m", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"15", ",", "1", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", 
       RowBox[{"-", "2"}], ",", "6"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "6", ",", "1"}], "}"}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"N", "[", 
  RowBox[{"Eigenvalues", "[", "m", "]"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"anim", "[", "m", "]"}]}], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellChangeTimes->{3.473560127420072*^9}]
}, Closed]]
},
WindowSize->{640, 750},
WindowMargins->{{155, Automatic}, {74, Automatic}},
ShowSelection->True,
FrontEndVersion->"7.0 for Linux x86 (32-bit) (February 25, 2009)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[568, 22, 304, 8, 36, "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.}],
Cell[875, 32, 8871, 235, 517, "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.}],
Cell[9749, 269, 637, 18, 77, "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.}],
Cell[10389, 289, 590, 17, 77, "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.}]
}, Closed]]
}
]
*)

(* End of internal cache information *)
